<template>
  <section class="play" v-if="isLoaded">
    <section class="play__image" v-if="state.activeTrack.artist.picture_medium" v-bind:style="{ backgroundImage: 'url(' + state.activeTrack.artist.picture_medium + ')' }">
      <section class="play__imageCover"></section>
    </section>
    <section class="play__imageAlbum" v-if="state.activeTrack.album.cover_medium" v-bind:style="{ backgroundImage: 'url(' + state.activeTrack.album.cover_medium + ')' }">
      <section class="play__imageAlbumCover"></section>
    </section>
    <section class="play__topRight">
      <a target="_blank" class="play__link" v-bind:href="state.activeTrack.link">
        <md-icon>share <md-tooltip md-direction="bottom">Play on Deezer</md-tooltip></md-icon>
      </a>
    </section>
    <section class="play__content">
      <section class="play__meta">
        <section class="play__trackName">{{state.activeTrack.title}}</section>
        <section class="play__artist" @click="navigateTo('artist', state.activeTrack.artist.id)">{{state.activeTrack.artist.name}}</section>
        <section class="play__album" @click="navigateTo('album', state.activeTrack.album.id)">{{state.activeTrack.album.title}}</section>
      </section>
      <section class="play__controls">
        <section class="play__control" @click="toggleShuffleMode()" v-bind:class="{ active: state.shuffleMode }">
          <md-tooltip md-direction="bottom">Shuffle</md-tooltip>
          <md-icon>shuffle</md-icon>
        </section>
        <section class="play__control" @click="playPrevious()">
          <md-tooltip md-direction="bottom">Play previous</md-tooltip>
          <md-icon>skip_previous</md-icon>
        </section>
        <section class="play__control playIcon" @click="play()">
          <md-tooltip md-direction="bottom">Play/Pause</md-tooltip>
          <md-icon class="mdPlayerIcon" v-if="!state.isPlaying">play_arrow</md-icon>
          <md-icon class="mdPlayerIcon" v-if="state.isPlaying">pause</md-icon>
        </section>
        <section class="play__control" @click="playNext()">
          <md-tooltip md-direction="bottom">Play next</md-tooltip>
          <md-icon>skip_next</md-icon>
        </section>
        <section class="play__control" @click="toggleRepeatMode()" v-bind:class="{ active: state.repeatMode }">
          <md-tooltip md-direction="bottom">Replay</md-tooltip>
          <md-icon>replay</md-icon>
        </section>
      </section>
      <section class="player" v-bind:class="{ isLoading: state.isLoading }">
        <section class="player__progress">
          <section class="player__currentTime">{{state.currentTime | trackTime}}</section>
          <section class="player__progressLineWrapper" @mousemove="onProgressMouseMove" @mouseleave="onProgressMouseLeave" @click="seek()">
            <section class="player__progressLoading"></section>
            <section class="player__progressLine">
              <section class="player__hoverProgress" v-bind:style="{ width: hoverProgress + '%' }"></section>
              <section class="player__activeProgress" v-bind:style="{ width: state.progress + '%' }"></section>
            </section>
          </section>
          <section class="player__endTime">{{state.activeTrack.duration | trackTime}}</section>
        </section>
        <section class="player__volume">
          <section class="player__volumeIcon" @click="toggleVolume()">
            <md-icon v-if="!isMute">volume_up</md-icon>
            <md-icon v-if="isMute">volume_mute</md-icon>
          </section>
          <section class="player__volumeLineWrapper" @mousemove="onVolumeMouseMove" @mouseleave="onVolumeMouseLeave" @click="setVolume()">
            <section class="player__volumeLine">
              <section class="player__volumeActive" v-bind:style="{ width: volume + '%' }"></section>
              <section class="player__volumeHover" v-bind:style="{ width: hoverVolume + '%' }"></section>
            </section>
          </section>
        </section>
      </section>
    </section>
  </section>
</template>

<script>
import Vue from 'vue';
import Component from 'vue-class-component';
import { Getter, State } from 'vuex-class';

@Component()
export default class ActiveTrack extends Vue {
  @State(state => state.audio)
  state;
  @Getter('volume') volume;

  hoverProgress = 0;
  hoverVolume = 0;

  get isLoaded() {
    return Boolean(this.state.activeTrack)
  }

  get isMute() {
    return this.volume <= 0;
  }

  onProgressMouseMove(event) {
    const { currentTarget, pageX } = event;
    const progress = (pageX - currentTarget.getBoundingClientRect().left) / currentTarget.offsetWidth;
    this.hoverProgress = Math.round(progress * 100);
  }

  onProgressMouseLeave() {
    this.hoverProgress = 0;
  }

  seek() {
    this.$store.dispatch('seek', this.hoverProgress);
  }

  onVolumeMouseMove(event) {
    const { currentTarget, pageX } = event;
    const progress = (pageX - currentTarget.getBoundingClientRect().left) / currentTarget.offsetWidth;
    this.hoverVolume = Math.round(progress * 100);
  } 

  onVolumeMouseLeave() {
    this.hoverVolume = 0;
  }

  setVolume() {
    this.$store.dispatch('setVolume', this.hoverVolume / 100);
  }

  play() {
    if (this.state.isPlaying) {
      this.$store.dispatch('pause');
    } else {
      this.$store.dispatch('play', this.state.activeTrack);
    }
  }

  playPrevious() {
    this.$store.dispatch('playPrev');
  }

  playNext() {
    this.$store.dispatch('playNext');
  }

  toggleVolume() {
    this.$store.dispatch('toggleVolume');
  }

  toggleRepeatMode() {
    this.$store.dispatch('toggleRepeatMode', !this.state.repeatMode);
  }

  toggleShuffleMode() {
    this.$store.dispatch('toggleShuffleMode', !this.state.shuffleMode);
  }

  navigateTo(type, id) {
    this.$router.push({
      name: 'play',
      params: { type, id },
    });
  }
}
</script>

<style lang="stylus" scoped>
.play
  width 546px
  height 250px
  position relative
  display flex
  background-color #1c212c

  &__image
  &__imageAlbum
    width 250px
    height 250px
    position absolute
    background-size cover
    background-position center

  &__image
    left 0

  &__imageAlbum
    right 0

  &__imageCover
  &__imageAlbumCover
    position absolute
    top 0
    left 0
    width 100%
    height 100%
    background-image linear-gradient(to bottom, rgba(28,33,44,.6) 50%, #1c212c 100%), linear-gradient(to right, rgba(28,33,44,.6) 50%, #1c212c 100%)

  &__topRight
    position absolute
    width 150px
    height 100px
    top 0
    right 0
    padding 14px 20px
    display flex
    justify-content flex-end
    z-index 50

  &__link
    text-decoration none !important
    .md-icon
      color rgba(255,255,255,.7)
      transition all -12s ease
    &:hover .md-icon
      color #fff

  &__content
    position relative
    width 100%
    display flex
    flex-direction column

  &__meta
    display flex
    flex-direction column

  &__trackName
    padding 36px 0 12px 0
    text-align center
    font-size 26px
    font-weight 900
    font-family 'Encode Sans', sans-serif
    line-height 28px

  &__artist
  &__album
    margin auto
    text-align center
    color #afafaf
    font-size 13px
    font-weight bold
    cursor pointer
    transition all .15s ease-in-out
    &:hover
      color #fff

  &__controls
    position absolute
    bottom 54px
    width 100%
    height 56px
    display flex
    justify-content center
    align-items center

  &__control
    width 40px
    height 40px
    margin 0 12px
    position relative
    display flex
    cursor pointer
    user-select none

    &.playIcon
      width 60px
      height 60px
      justify-content center
      align-items center
      overflow hidden
      border-radius 50%

    &:active
      .md-icon
        color yellow

  .player
    width 100%
    height 44px
    position absolute
    bottom 12px
    display flex
    justify-content center
    z-index 10

    &__progress
      width 350px
      position relative
      margin-right 16px
      display flex
      align-items center

    &__currentTime
    &__endTime
      position absolute
      font-size 12px
      font-weight bold
    
    &__currentTime
      left 0

    &__endTime
      right 0

    &__progressLineWrapper
      width calc(100% - 90px)
      height 12px
      position relative
      left 45px
      display flex
      align-items center
      cursor pointer

    &__progressLine
      width 100%
      height 2px
      position relative
      background-color #333
      cursor pointer

    &__activeProgress
      position absolute
      width 40%
      height 100%
      background-color yellow
      z-index 2

    &__hoverProgress
      position absolute
      width 60%
      height 100%
      background-color rgba(255,255,0,.5)
      z-index 1

    &__progressLoading
      width 100%
      height 2px
      position absolute
      top 5px
      background yellow
      box-shadow 0 0 24px rgb(205,203,0)
      opacity 0

    &.isLoading
      .player__progressLoading
        animation boxShadowLoading 1.2s infinite ease-in-out

    &__volume
      position relative
      width 120px
      display flex
      align-items center

    &__volumeIcon
      min-width 24px
      min-height 24px
      margin-right 12px
      position relative
      display block
      overflow hidden
      cursor pointer
      user-select none 
      transition all .15s ease-in-out
      &:hover
        opacity .9

    &__volumeLineWrapper
      width calc(100% - 20px)
      height 12px
      position relative
      background-color transparent
      cursor pointer

    &__volumeLine
      width 100%
      height 1px
      position absolute
      top 5px
      background-color #333

    &__volumeActive
      width 40%
      height 2px
      position absolute
      left 0
      background-color yellow
      z-index 2

    &__volumeHover
      position absolute
      left 0
      height 2px
      background-color rgba(255,255,0,.5)
      z-index 1

  .mdPlayerIcon
    width 32px
    min-width 32px
    height 32px
    min-height 32px
    font-size 34px !important
</style>

